function f = correctfactor_detSensor(ang, Xenergy, det_nu, det_sensorthickness)
%f = correctfactor_detSensor(ang, Xenergy, det_nu, det_sensorthickness)
% ang is an angle array generated by det_geometry.m
% det_nu is the linear absorption coefficient of a detector sensor in 1/mm.
% det_sensorthickness is thickness of the sensor in m.

if nargin < 3
    det_nu = absortpioncoefficientCdTe(Xenergy); % 1/cm
    det_nu = det_nu/10; % 1/cm to 1/mm
    det_sensorthickness = 0.5; % Perkin Elmer detector CdTe in mm.
end

if det_nu*det_sensorthickness > 5 % if det_sensorthickness is already to thick, no need for angular correction.
    f = ones(size(ang));
else
    f = 1./(1-exp(-det_nu*det_sensorthickness./cos(ang*pi/180)));
end
