function cv = FitLee_fitfunction(p, y, fitFunHandle, q, pnames, tag)
% function cv = FitLee_fitfunction(p, y, fitFunHandle, q, pnames, tag)
% This is the function to be fitted.

    % Calculation function
    %[predY, fit] = multivoight(parameters, q, datatag);
    % q : it can be either array or a cell for multiple data set
    % y : it can be either array or a cell for multiple data set
    % q and y should have the same length.
    % datatag: strings that are tags of plotted curves. 
    %       this can be either array or a cell for multiple data set.
if (nargin < 6)
   tag = [];
end
if ~iscell(p)
    p = num2cell(p);
end
p_str = cell2struct(p, pnames, 1);
if ~isempty(tag)    
    Iq = fitFunHandle(p_str, q, tag);
else
    Iq = fitFunHandle(p_str, q);
end
    assignin('base', 'Iq', Iq);
if iscell(Iq)
    Iqarray = cell2mat(Iq);
    Iqarray = Iqarray(:);
    yarray = cell2mat(y);
    yarray = yarray(:);
else
    Iqarray = Iq;
    yarray = y;
end
cv = chi_squared(yarray, Iqarray, 5);
    %fit.fit = [q(:), predY(:), y(:)];
end