function SAXSLee_loadDir
% SHOWSCAN Called by SAXSLee to show the current scan data.

hf = evalin('base', 'SAXSLee_Handle');
%settings = getappdata(hFigSAXSLee,'settings');
dirn = [];
scan = [];
% --- open GUI to display the selected scans
h = findall(0,'Tag','figSAXSLee_loadDir');
if ~isempty(h)
    figure(h);
else
    p0      = get(hf,'position');    % main figure position
    p1(3)   = 500;              % p1 is the setting figure position
    p1(4)   = 400;
    p1(1)   = p0(1)+p0(3)/2-p1(3)/2;
    p1(2)   = p0(2)+p0(4)/2-p1(4)/2;
    panelSize = [10 60 p1(3)-20 p1(4)-70];
    h = figure(...
        'Units','pixels',...
        'MenuBar','none',...
        'Units','pixels',...
        'Name','Spec Reader - Current Scan',...
        'NumberTitle','off',...
        'IntegerHandle','off',...
        'Position',p1,...
        'HandleVisibility','callback',...
        'Tag','figSAXSLee_loadDir',...
        'WindowStyle','normal',...
        'UserData',[]);
    hPanel1 = uipanel(...
        'Parent',h,...
        'BackgroundColor',get(h,'Color'),...
        'Title','Select Scan',...
        'Units','pixels',...
        'Tag','figSAXSLee_loadDir_panel1',...
        'Position',panelSize);
    hPushbuttonDir = uicontrol(...
        'Parent',hPanel1,...
        'Style','pushbutton',...
        'HorizontalAlignment','left',...
        'BackgroundColor','w',...
        'Position',[10 panelSize(4)-40 panelSize(3)-20 20],...
        'String','Select Directory',...
        'Value',1,...
        'callback',@callback_PushbuttonDir,...
        'Tag','figSAXSLee_loadDir_PushbuttonDir');
    hText1 = uicontrol(...
        'Parent',hPanel1,...
        'Style','text',...
        'BackgroundColor','w',...
        'Position',[10 panelSize(4)-65 panelSize(3)-300 20],...
        'String','file filter',...
        'Tag','figSAXSLee_loadDir_edit1');
    uicontrol(...
        'Parent',hPanel1,...
        'Style','edit',...
        'BackgroundColor','w',...
        'Position',[10+panelSize(3)-300+10 panelSize(4)-65 270 20],...
        'String','',...
        'Tag','figSAXSLee_loadDir_edit1');
    hPushbuttonList = uicontrol(...
        'Parent',hPanel1,...
        'Style','pushbutton',...
        'HorizontalAlignment','left',...
        'BackgroundColor','w',...
        'Position',[10 panelSize(4)-90 panelSize(3)-20 20],...
        'String','List files in the directory',...
        'Value',1,...
        'callback',@callback_PushbuttonList,...
        'Tag','figSAXSLee_loadDir_PushbuttonList');
    uicontrol(...
        'Parent',hPanel1,...
        'Style','edit',...
        'BackgroundColor','w',...
        'Position',[10 10 panelSize(3)-20 panelSize(4)-100],...
        'String','',...
        'Max',2,...
        'Min',0,...
        'HorizontalAlignment','center',...
        'Tag','figSAXSLee_loadDir_edit2');
    hPushbuttonUpdate = uicontrol(...
        'Parent',h,...
        'Style','pushbutton',...
        'String','Update',...
        'tag','figSAXSLee_loadDir_pushbuttonUpdate',...
        'Position',[p1(3)/2-130 20 50 25],...
        'Callback',@callback_PushbuttonUpdate);
    hPushbuttonAccept = uicontrol(...
        'Parent',h,...
        'Style','pushbutton',...
        'String','Accept',...
        'tag','figSAXSLee_loadDir_pushbuttonAccept',...
        'Position',[p1(3)/2-60 20 50 25],...
        'Callback',@callback_PushbuttonAccept);
    hPushbuttonClose = uicontrol(...
        'Parent',h,...
        'Style','pushbutton',...
        'String','Close',...
        'tag','figSAXSLee_loadDir_pushbuttonClose',...
        'Position',[p1(3)/2+10 20 50 25],...
        'Callback','delete(gcf);');
    hPushbuttonImageAccept = uicontrol(...
        'Parent',h,...
        'Style','pushbutton',...
        'String','Accept',...
        'tag','figSAXSLee_loadDir_pushbuttonImageAccept',...
        'Position',[p1(3)/2+80 20 50 25],...
        'Callback',@callback_PushbuttonImageAccept);
end

%================================================================
% --- callback of popupmenu1
%================================================================
    function callback_PushbuttonDir(hObject,eventdata)
        hf2 = findobj('Tag','figSAXSLee_loadDir');
        pb1 = findobj(hf2,'Tag','figSAXSLee_loadDir_PushbuttonDir');
        hEdit2      = findobj(hf2,'Tag','figSAXSLee_loadDir_edit2');

        directoryname = uigetdir;
        if ~isstr(directoryname)
            return;
        else
            dirn = directoryname;
        end

    end

    function callback_PushbuttonList(hObject,eventdata)
        hf2 = findobj('Tag','figSAXSLee_loadDir');
        hEdit2      = findobj(hf2,'Tag','figSAXSLee_loadDir_edit2');
        hEdit1      = findobj(hf2,'Tag','figSAXSLee_loadDir_edit1');
    filefilter = get(hEdit1, 'string');

    if isempty(dirn)
        dirn = pwd;
    end

    [FileList, scan] = listFileinDir(dirn, filefilter, 'name');

    set(hEdit2, 'string', FileList)

    end

    function callback_PushbuttonUpdate(hObject,eventdata)
    % multiple settings.....

    hFigSAXSLee = findobj('Tag','SAXSLee_Fig');
    settings = getappdata(hFigSAXSLee,'settings');
    %setall = evalin('base', 'setall');
    setall = evalin('base', 'setall');
    %assignin('base','setall', setall);

    Nset = numel(setall);
    for i=1:Nset
        file = setall{i}.file;
        if findstr(file, 'LoadDir');
            scano = setall{i}.scan;
            FileList = listFileinDir(scano.Dir, scano.filefilter, scano.filesort);
            setall{i}.scan.filen = FileList;
        end
    end
    %assignin('base','setall', setall);
    assignin('base','setall', setall);
    end

    function callback_PushbuttonAccept(hObject,eventdata)
    % multiple settings.....

    hFigSAXSLee = findobj('Tag','SAXSLee_Fig');
    settings = getappdata(hFigSAXSLee,'settings');
    setall = evalin('base', 'setall');
    %assignin('base','setall', setall);

    scan.fidPos = 1;
    Nset = numel(setall);
    settings.averageDir = '';
    setall{Nset}.scan = scan;
    settings.path = dirn;

    Nset = Nset + 1;
    loaddir = strcat('LoadDir', num2str(Nset));
    settings.file  = loaddir;
    specfiles = [];
    %setall{Nset} = settings;
    
    for i=1:Nset
        specfiles{i} = setall{i}.file;
    end

    set(findobj(hFigSAXSLee, 'tag', 'SAXSLee_PopupmenuX'), 'string', specfiles);
    assignin('base','setall', setall);
    end

    function callback_PushbuttonImageAccept(hObject,eventdata)
    % multiple settings.....

    hFigSAXSLee = findobj('Tag','SAXSLee_Fig');
    settings = getappdata(hFigSAXSLee,'settings');
    setall = evalin('base', 'setall');
    %assignin('base','setall', setall);

    scan.fidPos = 1;
    Nset = numel(setall);
    %settings.rootDir = scan.Dir;
    setall{Nset}.scan = scan;
    settings.rootDir = dirn;

    Nset = Nset + 1;
    loaddir = strcat('LoadImageDir', num2str(Nset));
    settings.file  = loaddir;
    specfiles = [];
    %setall{Nset} = settings;
    
    for i=1:Nset
        specfiles{i} = setall{i}.file;
    end

    set(findobj(hFigSAXSLee, 'tag', 'SAXSLee_PopupmenuX'), 'string', specfiles);
    assignin('base','setall', setall);
    end

end
