function [sumFq, Q] = indiffrac(hk, latticep, molp, ang)
% function [Fq, Q] = indiffrac(reflec, latticep, molp, ang)
%   reflec = [h, k], ex [1, 1];
%   latticep = [aaxis, baxis, gamma], ex [5.35, 8.9, 90];
%   molp = [length, width];
%   ang = euler angle. ex[10, 10, 0];(tilt angle, azimuthal angle, rotation angle)
% function to calculate peak position and its amplitude.
% parameters are the same used for the function inMoleculedraw.m
% inMoleculedraw.m function will draw the real space structure.
% Byeongdu Lee
% Oct. 17. 2004

h = hk(1);k = hk(2);
d = molp(1);w = molp(2);
a = latticep(1);b = latticep(2);
[qx, qy] = rlattice2d(a, b, latticep(3), h, k);
%qxv = qxv*h;
%qyv = qyv*k;
%qp = qxv+qyv;
%qx = qp(1);qy=qp(2);
qz = 0;

ang = deg2rad(ang);
sumFq = [];

for i=1:length(ang(:,1));
    %qz = sin(ang(1))*(cos(ang(2))*qx + sin(ang(2))*qy) + cos(ang(1))*qz;
    th = ang(i, 1);
    ph=ang(i, 2);
    xi=ang(i, 3);
    qz = -sin(th)/cos(th)*(cos(ph)*qx + sin(ph)*qy)
%    th = th;ph = -ph;xi = -xi;
    Q = [qx;qy;qz];

    Rinv = [cos(th)*cos(ph)*cos(xi)-sin(ph)*sin(xi),cos(th)*sin(ph)*cos(xi)+cos(ph)*sin(xi),-sin(th)*cos(xi);
        -cos(th)*cos(ph)*sin(xi)-sin(ph)*cos(xi),-cos(th)*sin(ph)*sin(xi)+cos(ph)*cos(xi),sin(th)*sin(xi);
        sin(th)*cos(ph),sin(th)*sin(ph),cos(th)];
    q = Rinv*Q;
    Fq(i) = sinc(q(1)*w/2/pi).*sinc(q(3)*w/2/pi);
%    sin(q(1)*w/2+eps)./(q(1)*w/2 + eps).*sin(q(3)*d/2+eps)./(q(3)*d/2+eps)
end
if length(Fq) == 2
    sumFq = Fq(1) + Fq(2)*cos(pi*(h+k));
else
    sumFq = Fq(1) + Fq(1)*cos(pi*(h+k));
end