function [a, b] = indiffrac3(q11, q11_, q12, q12_)
% function [a, b] = indiffrac3(q11, q11_, q12, q12_)
% This function calculate the lattice vector a and b
% from the q11, q1-1, q12, q1-2 peak position
% program for inplane x-ray diffraction.
% Nov. 5. 2004.
% Byeongdu Lee
A1 = (q11_^2 + q11^2)/(q12_^2 + q12^2);
A2 = (q11_^2 - q11^2)/(q12_^2 - q11^2);
by = 2*pi*sqrt(3/(q12^2 + 1/2*q11_^2 - 3/2*q11^2));
bx2 = 2*(1-A1)/((8*A1-2)*((4+2*A2)/(3*A2))^2 - 2*(1-A1))*by^2;
if ((4+2*A2)/(3*A2)) > 0
    bx = sqrt(bx2);
else
    bx = -sqrt(bx2);
end
ax = (4+2*A2)/(3*A2)*bx;
a = [ax, 0];
b = [bx, by];