function [Atomkind, Atomposi] = loadstr(filename)
% 'Goldopen' is to read just one Gold detector file at BESSRC
% usage :
%		for example
% 		[A, p] = Goldopen('test.xxx') : the result will be column vector.
% you can also read 2-dimensional file as matrix form.
% p is the Scaler Counts.
% p(2) is ICdata, p(3) is Photodiode data;

fid = fopen(filename, 'r');

if (fid<0) 
	error(['Couldn''t find ' file]);
end

%xextent = 1536;
%yextent = 1536;

line=fgetl(fid);
% ==================== Header bytes
while line~=-1
    [paramname, paramvalue] = strtok(line, ' ');
	if strcmp(strtok(line,' '),'cell')
        break
	end
	line=fgetl(fid);
end
cellpar = str2num(paramvalue(2:end-1));

line=fgetl(fid);
% ==================== Header bytes
while line~=-1
    [paramname, paramvalue] = strtok(line, ' ');
	if strcmp(strtok(line,' '),'atoms')
        disp('-----')
        break
	end
	line=fgetl(fid);
end

i=1;
line=fgetl(fid);
% ==================== Header bytes
while line~=-1
    [paramname, paramvalue] = strtok(line, ' ');
    Atomposi(i, :) = str2num(paramvalue((length((paramname))+1):end-1));
%    Atomkind(i) = paramname;
    if (strcmp(paramname, 'PT'))
        Atomkind(i) = 1;
    else
        Atomkind(i) = 0;
    end
	line=fgetl(fid);
    i = i+1;
end


