function [qxy, qz] = rlattice2d(A, B, C, h, k, l);
% A, B, C is real space lattice vector
% this program will calculate the peak position for power 3D.
% having fiber symmetry.
%
%a = A*[1, 0, 0];
%b = B*[cos(deg2rad(ga)), sin(deg2rad(ga)), 0];
%z = [0, 0, 1];
a = A; b= B; c=C;
V = dot(c, cross(a, b));
ar = cross(b, c)/V;
br = cross(c, a)/V;
cr = cross(a, b)/V;

q = 2*pi*(h*ar + k*br + l*cr);
qxy = sqrt(q(1)^2 + q(2)^2);
qz = q(3);
%ax = A;
%bx = B*cos(deg2rad(ga));
%by = B*sin(deg2rad(ga));
%qx = 2*pi*1/ax
%qy = 2*pi*1/ax/by*(-1*bx + 1*ax)