function [tth, name, pname, p] = triclinic(x,p,flag)

name = 'triclinic';
pname = 'cell parameter';

h = x(:,1);
k = x(:,2);
l = x(:, 3);
a = p(1);
b = p(2);
c = p(3);
al = p(4);
be = p(5);
ga = p(6);

al = deg2rad(al);
be = deg2rad(be);
ga = deg2rad(ga);

V = a.*b.*c.*sqrt(1-cos(al).^2-cos(be).^2-cos(ga).^2 + 2.*cos(al).*cos(be).*cos(ga))
S11 = b.^2.*c.^2.*sin(al).^2;
S22 = a.^2.*c.^2.*sin(be).^2;
S33 = a.^2.*b.^2.*sin(ga).^2;
S12 = a.*b.*c.^2.*(cos(al).*cos(be) - cos(ga));
S23 = a.^2.*b.*c.*(cos(be).*cos(ga) - cos(al));
S13 = a.*b.^2.*c.*(cos(ga).*cos(al) - cos(be));

d = V.*sqrt(1./(S11.*h.^2 + S22.*k.^2 + S33.*l.^2 + 2.*S12.*h.*k + 2.*S23.*k.*l + 2.*S13.*h.*l));

q = 2.*pi./d;

tth = rad2deg(asin(1.54./2./d)).*2;