function results = load3circle(scanN, filename)
% Loading the selected scan data from the acquired by 3circle goniometer
% program.
% usage :
% results = load3circle(scanN, filename)
%   if you do not input the filename, it will load uigetfile...
% 2002. Nov. 8.

results = [];
if nargin == 1
    [filen, pathn] = uigetfile('*.dat', 'Pick 3-circle data');
    fid=fopen([pathn, filen]);
elseif nargin ==2
    fid=fopen(filename);
end

while 1
    tline = fgetl(fid);
    if length(tline) > 7
        if (tline(1:6) == 'Scan :') & (str2num(tline(7:end)) == scanN)
            tline = fgetl(fid);
            break
        end
    end    
end

while 1
    tline = fgetl(fid);
    if (tline ~= -1)
        if (isempty(str2num(tline)) ~= 1)
            A = sscanf(tline,'%f');
            results = [results
                A'];
        else
            break
        end
    else
        break
    end
end
evalstr = ['save ', filename, '_scan', num2str(scanN),'.dat results -ascii'];
eval(evalstr)
fclose(fid);