function Res = subback(R, H, Rb, Hb, Correctionby, incidenceCorrection)
% background subtraction software
% Res = subback(R, H, Rb, Hb, Correctionby, incidenceCorrection)
% IncidenceCorrection = 1 then, Rb will be corrected by IC1 data in the header
% Correctionby can be
%        Scin            ----- by scintillation counter
%        Tr                ----- by Transmittance
%        IC2              ----- by IC2 data.

if incidenceCorrection == 1
   Rb = Rb./Hb.IC1*H.IC1;
end 

if Correctionby == 'Scin' 
   Res = R- Rb./Hb.Scin.*H.Scin;
elseif Correctionby == 'Tr'
   Res = R- Rb./Hb.Tr.*H.Tr;
elseif Correctionby == 'IC2'
   Res = R- Rb./Hb.IC2.*H.IC2;
end
