function Iq = debye2d(varargin)
% debye function for 2D random orientatoin (or fiber)
% Byeongdu Lee

if numel(varargin) == 3
    qr = varargin{1};
    qz = [];
    x = varargin{2};x = x(:);
    y = varargin{3};y = y(:);
    z = zeros(numel(x), 1);
    atm = [];
    atmFq = [];
elseif numel(varargin) >= 4;
    q = varargin{1};% [qr, qz];
    qr = q(:,1);
    qz = q(:,2);
    x = varargin{2};x = x(:);
    y = varargin{3};y = y(:);
    z = varargin{4};z = z(:);
    if numel(varargin) > 4
        atm = varargin{5};
        atmFq = varargin{6};
    end
end    

j = sqrt(-1);
dtheta = pi/50;
theta = 0:dtheta:2*pi;
[~, xv] = ndgrid(qr, x);
[qv, yv] = ndgrid(qr, y);
if ~isempty(atm)
    [~, atm] = ndgrid(qr, atm);
end
Iq = zeros(numel(qr), numel(theta));
for i=1:numel(theta)
    qx = qv*cos(theta(i));
    qy = qv*sin(theta(i));
    % Atomic scattering factor..
    if ~isempty(atm)
        Fatm = atmFq(atm);
    else
        Fatm = 1;
    end
    %
    F = Fatm.*exp(-j*(qx.*xv + qy.*yv));
    if ~isempty(qz)
        Fz = exp(-j*qz*z');
    else
        Fz = 1;
    end
    F = sum(F.*Fz, 2);
    Iq(:, i) = abs(F).^2;
end
Iq = trapz(Iq,2)*dtheta/max(theta);