function [Iq, dl] = debyecal(q, coord)
tic
    dl = distNzero(coord);
toc
    ul = 2*ones(size(dl));
    [delta, w] = getdeltaw(q, 20);
    [S, D] = nofsample(dl, delta, w);
    Iq = zeros(size(q));
tic
    for i=1:numel(q)
        Iq(i) = Wk_U(q(i), S(i), delta(i), w(i), dl, ul);
        disp(i)
    end
toc
end

function [S,D] = nofsample(dl, delta, w)   % for a box function of U(x)
    D = max(dl);
    S = floor((D+w/2)./delta);
end

function [delta, w] = getdeltaw(qmax, factor)
    % factor should be bigger than 1;
    if nargin ==1
        factor = 1;
    end
    if factor > 1;
        disp('factor should be bigger than 1')
    end
    deltamax = 1./qmax/2;
    delta = deltamax/factor;
    w = delta*(factor/2); % w should be smaller than 2*deltamax and bigger than delta, for a box function of U(x).
end
