function [dist, ff, i, j, ang] = distNzero(pnts, atm)
% function [dist, ff, i, j, ang] = distNzero(pnts)
% dist : distance between i and j
% ff : form factor 
% i and j are the index
% ang : phase angle (for 2D system only)
%
% Byeongdu Lee
% Dec. 5, 2012
% modified Dec. 19. 2013 for 2D phase angle
dim = 3;
if size(pnts, 2) == 2
    pnts = [pnts, zeros(size(pnts(:,1)))];
    dim = 2;
end
if nargin == 1
    if dim == 2
        [dist,ff, i,j,ang] = distNzero_(pnts);
    else
        [dist,ff, i,j] = distNzero_(pnts);
        ang = [];
    end
elseif nargin==2
    if dim == 2
        [dist,ff, i,j,ang] = distNzero_(pnts,atm);
    else
        [dist,ff, i,j] = distNzero_(pnts,atm);
        ang = [];
    end
end
