function [y, tim] = cell_correlation(CellDataofImages)
img = cell2mat(CellDataofImages);
Npixel = numel(CellDataofImages{1});
Nimg = size(CellDataofImages, 2);
pixel_time = reshape(img, Npixel, Nimg);
y = [];
tim = 0:Nimg-1;
yvar = mean(pixel_time, 2).^2;
y = zeros(Npixel, Nimg);
for t = 1:numel(tim)
    y(:,t) = acf_k(pixel_time, tim(t));
end
y = y./repmat(yvar, 1, numel(tim));
%y = correlation(pixel_time);
% for i=1:Npixel
%     m = correlation(pixel_time(i, :));
% %        m = xcorr2(pixel_time(i, :));
%     y = [y;m];
% end

function ta2 = acf_k(y,k)
% ACF_K - Autocorrelation at Lag k
% acf(y,k)
%
% Inputs:
% y - series to compute acf for
% k - which lag to compute acf
% 
N = size(y, 2);
M = size(y, 1);
cross_sum = zeros(M, N-k) ;

% Numerator, unscaled covariance
%Am = zeros(M, N-k);
for i = (k+1):N
    cross_sum(:, i-k) = y(:, i).*(y(:, i-k)) ;
end

% Denominator, unscaled variance
ta2 = mean(cross_sum, 2);


% function y = correlation(r)
% % r = mxn matrix, n is the time axis and m is pixel axis.
%     lr = size(r, 2);
% 	n = 2^(ceil(log (lr*2 -1) / log(2)));
% 
%     D = fft(r, n, 2);
% %    R = fft(r, n, 2);
% 
% % -------------------- computes -----------------
% 
% 
%     y = D.*conj(D);		% correlation
% 
% % -------------------- end computes -----------------
% 
%     y = ifft(y, n, 2);
%     y = y(:, 1:fix(n/2));
% %    y = y(1:lr);
%     