noimages = 1000; %number of images
noparticles = 20; % number of particles
nocolumn = 1; % number of column
particlecontrast = 1;
imgcontrast = 0;
blockcontrast = 0;
steps = 0.025; %speed of particles
Pro_changeparticledirection = 1; % probability to change the direction of random walk...
Radiusofparticle = 0.5;
particleshape = 1;% for a sphere, 2 for a rectangle....
ximglen = 50;
yimglen = 50;
img = zeros(ximglen,yimglen) + imgcontrast;
imgn = img;

fftedimgsizex = 150;
fftedimgsizey = 150;
imgIndS = fix(fftedimgsizex/5);
ROIx = imgIndS:(fftedimgsizex-imgIndS);
ROIy = imgIndS:(fftedimgsizex-imgIndS);

x_strip = 40;
y_strip = yimglen-2*Radiusofparticle;
xmax = x_strip + 2*Radiusofparticle;
ymax = y_strip + 2*Radiusofparticle;

xspaces = 20;

imgblock = zeros(xmax, ymax) + blockcontrast;
tmpimg = imgblock;

xa = 1:xmax;
ya = 1:ymax;
[xind, yind] = meshgrid(xa, ya);
xind = reshape(xind', numel(xind), 1);
yind = reshape(yind', numel(yind), 1);
cols = {};
x1 = [];
y1 = [];
xx = {};
yy = {};

for k = 1:nocolumn
    for t = 1:noparticles
%    for t = 1:1
%        steps = rand(1);
        [x1, y1] = diffusionTKurs_rand(1, noimages, x_strip, y_strip, steps, 0, Pro_changeparticledirection);
        xx{t} = x1 + Radiusofparticle;
        yy{t} = y1 + Radiusofparticle;
    end
    cols{k}.x = xx;
    cols{k}.y = yy;
%    cols{k}.tmpimg = imgblock;
%(k-1)*(xmax+5) + 1
    cols{k}.xstart = (k-1)*(xmax+fix(xspaces*(rand(1)+1))) + 1 ;% + 
end

figure(1);
subplot(1,2,1);
kk = imagesc(img);axis image;
subplot(1,2,2);
imgtmp = zeros(fftedimgsizex, fftedimgsizey);
pp = imagesc(imgtmp(ROIx, ROIy), [-5, 15]);axis image;%colorbar

corimg = {};

for t = 1:noimages
    imgn = img;
    for p = 1:nocolumn
        tmpimg = imgblock;
        for k = 1:numel(xx)
            % rectangular particle
            if particleshape == 2
                kx = find(abs(xa-fix(cols{p}.x{k}(t))-5) <= Radiusofparticle);
                ky = find(abs(ya-fix(cols{p}.y{k}(t))-5) <= Radiusofparticle);
                tmpimg(kx, ky) = particlecontrast;
            elseif particleshape == 1
                % circular particle
                tind = find((xind-fix(cols{p}.x{k}(t))).^2 + (yind-fix(cols{p}.y{k}(t))).^2 <= Radiusofparticle^2);
                tmpimg(tind) = particlecontrast;
            end
        end
%        tmpimg = reshape(tmpimg, xmax, ymax);
        imgn(cols{p}.xstart:xmax+cols{p}.xstart-1, 1:ymax) = tmpimg;
    end
    
    tn = abs(fftshift(fft2(imgn, fftedimgsizex, fftedimgsizey))).^2;
    corimg{t} = tn;% + rand(size(tn))+1;
    
    set(kk, 'cdata', imgn);
    set(pp, 'cdata', log(tn(ROIx, ROIy)));
    drawnow
    pause(1/50);
end
%%
figure(10)
subplot(2, 1, 1)
pixel1 = cellfun(@(x) x(100*20), corimg);
plot(1:numel(corimg), pixel1)
subplot(2, 1, 2)
[cf_out, lag] = cell_correlation(corimg);
semilogx(lag, cf_out(100*20, :)); ylim([0.8, 2])

return
%[cf_out, all_q] = cell_correlation3(corimg);
qst = numel(cf_out(1,:)) - 1;
zeroind = find(cf_out(:,1) == 0);
figure(10);
res = [1, 1.4, 6, 1];
fitv = [];
for t=1:qst
    semilogx(cf_out(zeroind:end,1), cf_out(zeroind:end,t+1), 'ro');
    hold on;
    xv = cf_out(zeroind:90+zeroind,1);
    yv = cf_out(zeroind:90+zeroind,t+1);
    res = nlinfit(xv, yv, 'stretchedExp', res);
    fitv = [fitv;res'];
%    semilogx(cf_out(zeroind+1:end,1), stretchedExp(res, cf_out(zeroind+1:end,1)), 'b');
    semilogx(xv, stretchedExp(res, xv, 'b'));
end
hold off;

figure(11);
loglog(all_q, fitv(:,2), 'ro')
hold on
loglog(all_q, 0.001./all_q.^2)
loglog(all_q, 0.1./all_q)
hold off
