function [W, DI] = iwishrnd(Tau, df, DI, n)
if nargin < 4
    n = 1;
end
if (nargin < 2)
  print_usage ();
end

if nargin < 3 || isempty(DI)
  try
    D = chol(inv(Tau));
  catch
    error('Cholesky decomposition failed; Tau probably not positive definite')
  end
  DI = D';
else  
  D = DI';  
end

w = wishrnd([], df, D, n);

if n > 1
  p = size(D, 1);
  W = nan(p, p, n);
end

for i = 1:n
  W(:, :, i) = inv(w(:, :, i));
end

end