function step1( sourcefile )
% Input ( sourcefile )
%      filter 'sourcefile' using a high-pass/low-pass filters...
%
% Output: sourcefile + '_h.jpg' -AND- '_l.jpg
%

% order of filter 
order = 20;

% cutoff frequency
cutoff = 0.1;

% setup frequency response
[f1,f2] = freqspace(order,'meshgrid');
d = find(f1.^2+f2.^2 < cutoff^2);
Hd = zeros(order);
Hd(d) = 1;
Hd = 1-Hd; 

% compute filter coefficients
h = fsamp2(Hd);

% load original image
i = imread( strcat(sourcefile, '.jpg') );

% filtering image
J = mat2gray(filter2(h,i));

% show filtered image
figure(1)
imshow(J)

imwrite( J, strcat(sourcefile, '_h.jpg') );

%----------------------------------------------------------

order = 20;
cutoff = 0.05;
[f1,f2] = freqspace(order,'meshgrid');
d = find(f1.^2+f2.^2 < cutoff^2);
Hd = zeros(order);
Hd(d) = 1;
h = fsamp2(Hd);

% filtering image
J = mat2gray(filter2(h,i));

% show filtered image
figure(1)
imshow(J)

imwrite(J, strcat( sourcefile, '_l.jpg' ) );



