function h = drawmolecule(atoms)
% function drawmolecule(atoms)
% atoms = [x, y, z, AtomicNumber];

light;
light('Position',[-1 -1 -2]);
if size(atoms, 1) < 30
    nline = 30;
else
    if size(atoms, 1) < 100
        nline = 20;
    else
        nline = 6;
    end
end
[x,y,z] = sphere(nline);

if isa(atoms, 'PDB') | isa(atoms, 'molecule')
    at = atoms;
else
    if isstruct(atoms)
        if isfield(atoms, 'pdb')
            atoms = atoms.pdb;
            atoms = [atoms.X(:), atoms.Y(:), atoms.Z(:), atoms.atom(:)];
        elseif isfield(atoms, 'x')
            atoms = [atoms.x(:), atoms.y(:), atoms.z(:), atoms.atom(:)];
        elseif isfield(atoms, 'X')
            atoms = [atoms.X(:), atoms.Y(:), atoms.Z(:), atoms.atom(:)];
        end
        at = molecule(atoms.atom);
        at.X = atoms(:,1);
        at.Y = atoms(:,2);
        at.Z = atoms(:,3);
    else
        at = molecule(atoms(:,4));
        at.X = atoms(:,1);
        at.Y = atoms(:,2);
        at.Z = atoms(:,3);
    end
end
h = zeros(size(atoms, 1), 1);
for i=1:numel(at.Atom);
    %a = at(atoms(i,4));
    %r = a.Radius;
    %color = a.Color;
    r = at.Radius(i);
    color = at.Color(i, :);
    h(i) = surface('XData',at.X(i) + r*x,'YData',at.Y(i) + r*y,...
        'ZData',at.Z(i) + r*z,'FaceColor',color,...
        'EdgeColor','none','FaceLighting','gouraud');
end
