function dmax = facefacedistance(obj)
% calculate face-face distance of an obj.
%ref_pnt = mean(obj.vertices(obj.faces(1, :),:));
if iscell(obj.faces)
    Nfaces = numel(obj.faces);
else
    Nfaces = size(obj.faces, 1);
end
dmax = 0;
t = zeros(Nfaces, 3);
for i=1:Nfaces
    if iscell(obj.faces)
        F1 = obj.faces{i};
    else
        F1 = obj.faces(i, :);
    end
    for j=i+1:Nfaces
        if iscell(obj.faces)
            F2 = obj.faces{j};
        else
            F2 = obj.faces(j, :);
        end
        if isplanesparallel(obj.vertices(F1, :),obj.vertices(F2, :))
            d = distancePointPlane(obj.vertices(F1(1), :), vert2plane(obj.vertices(F2, :)));
            d = abs(d);
            fprintf('The faces %i and %i are parallel and the distance is %0.3f\n', i, j, d);
            if d > dmax
                dmax = d;
            end
        end
    end
end