function inorout = inUnitcell(cell, point)
% cell could be either the equation of a plane or three points per plane.
% return 1 for in
%        0 for out
%        -1 for on
%
%topplane = cell(1, :);
%bottomplane = cell(2,:);
%leftplane = cell(3, :);
%rightplane = cell(4, :);
%backplane = cell(5, :);
%frontplane = cell(6, :);
% cell could be an object;
%   cell.vertices 
%   cell.faces = [top;bottom;left;right;back;front]
% when it is a cube
% o.vertices = [
%     0     0     0
%     1     0     0
%     1     1     0
%     0     1     0
%     0     0     1
%     1     0     1
%     1     1     1
%     0     1     1
%   ];
%   cell.faces = [5 6 7 8; 1 2 3 4; 5 8 4 1; 6 7 3 2; 8 7 3 4; 5 6 2 1;]
%   
% when it is the eqatuion of a plane, the dimension of a cell is [6, 4]
% because 6 planes and 4 coefficients for each.
% otherwise, the dimension of a cell is [6, 9]
% 6 planes and 3 points per each plane and 3 coordinates(x,y,z) for a point.
nc = zeros(6, 4);

if isstruct(cell)
    o = cell;
    cell = [];
    for i=1:6
       cell(i, 1:3) = o.vertices(o.faces(i,1), :);
       cell(i, 4:6) = o.vertices(o.faces(i,2), :);
       cell(i, 7:9) = o.vertices(o.faces(i,3), :);
    end
end

if size(cell, 2) == 9
    for i=1:6
        nc(i, :) = equationofplane(cell(i, 1:3), cell(i, 4:6), cell(i, 7:9));
%        nc(i, :) = [A, B, C, D];
    end
else
    nc = cell;
end

inorout = 1;

for i=1:2:5
    A = nc(i, 1);
    B = nc(i, 2);
    C = nc(i, 3);
    D = nc(i, 4);
    s = A*point(1) + B*point(2) + C*point(3) + D;
    if s > 0
        inorout = 0;
        return
    elseif s == 0
        inorout = -1;
        return
    end
end

for i=2:2:6
    A = nc(i, 1);
    B = nc(i, 2);
    C = nc(i, 3);
    D = nc(i, 4);
    s = A*point(1) + B*point(2) + C*point(3) + D;
    if s < 0
        inorout = 0;
        return
    elseif s == 0
        inorout = -1;
        return
    end
end