function V = intersect_volume_polyhedron_sphere(obj, radius, center)
% Calculate the intersect volume of a sphere and a polyhedron. 
% V = intersect_volume_polyhedron_sphere(obj, radius, center)
% V = intersect_volume_polyhedron_sphere(obj, sphobj)
% obj
%   vertices, mx3 matrix
%   faces
% sphobj
%   radius
%   center, 3x1 matrix
N = 100;
x = linspace(-radius, radius, N);
[X,Y,Z] = meshgrid(x,x,x);
Q = [X(:), Y(:), Z(:)];
d = sum(Q.^2, 2) < radius^2;
Q = Q(d, :);
Q = Q + center;
O = inPolyhedron2(obj, Q);
V = sum(O)*(2*radius/(N-1))^3;