function bool = isplanesparallel(V1, V2)
% check to see whether two planes defined by vertices V1 and V2 are
% parallel or not. Both V1 and V2 should have more than 3 vertices.
% Byeongdu Lee
% Nov. 2017.
N1 = planeNormal([V1(1, :), V1(2, :)-V1(1, :), V1(3, :)-V1(1, :)]);
N2 = planeNormal([V2(1, :), V2(2, :)-V2(1, :), V2(3, :)-V2(1, :)]);
bool = isParallel3d(N1, N2);