function [hd, rvc] = showhkl(h,k,l,mat)
% function [hd, rvc] = showhkl(h,k,l,mat)
% showhkl(h, k, l) or showhkl(h, k, l, mat)
if nargin < 4
    mat = [1,0,0;0,1,0;0,0,1];
end

vec = [h,k,l];
rvc = zeros(3);
t = (vec == 0);
if (sum(abs(vec))==0)
    disp('at least one of h, k, and l should not be 0');
    return
end
%rvc = [];
for i=1:numel(vec)
    tmpv = [0,0,0];
    if t(i) ~= 1
        tmpv(i) = 1/vec(i);
        rvc(i, :) = tmpv;
    else
        nonz = find(vec ~=0);
        tmpv(i) = 1;
        tmpvt = [];
        for k=1:numel(nonz)
            tmp = tmpv;
            tmp(nonz(k)) = 1/vec(nonz(k));
            tmpvt = [tmpvt; tmp];
        end
        tmpv = tmpvt;
        rvc(i,:) = tmpv(1,:);
        if numel(nonz) == 2
            rvc(4,:) = tmpv(2,:);
        else
            tmpv = [0,0,0];
            tmpv(tmpv == 0) = 1;
            tmpv(nonz(1)) = 1/vec(nonz(1));
            rvc(4,:) = tmpv;
        end
    end
end

if numel(rvc(:,1)) == 4
    nom(1) = norm(rvc(3,:) - rvc(2,:));
    nom(2) = norm(rvc(4,:) - rvc(2,:));
    if nom(2) < nom(1)
        tmpv = rvc(3,:);
        rvc(3,:) = rvc(4,:);
        rvc(4,:) = tmpv;
    end
end

for k=1:3
    if sum(rvc(:,k)<0) > 0
        rvc(:,k) = rvc(:,k) + 1;
    end
end

for i=1:numel(rvc)/3
    rvc(i,:) = rvc(i,:)*mat';
end

hd = patch(rvc(:,1), rvc(:,2), rvc(:,3), 'r', 'edgecolor', 'r', 'edgealpha', 1, 'FaceAlpha', 0.7);