function obj = voronoi_polyhedral_shell(ph, shell_thickness)
% When a polyhedron is given, this construct a core of which faces are
% equally spaced in from the orginal faces.
% 
vt = ph.vertices;
cm = mean(vt);
x = vt - cm;
alleqn = zeros(numel(ph.faces), 4);
for i=1:numel(ph.faces)
    vi = x(ph.faces{i}, :);
    p1 = vi(1, :);
    p2 = vi(2, :);
    p3 = vi(3, :);
%     ret = equationofplane(p1, p2, p3);
%     A = ret(1);B = ret(2);C = ret(3);D = -ret(4);
    A = p1(2) *(p2(3) - p3(3)) + p2(2) *(p3(3) - p1(3)) + p3(2) *(p1(3) - p2(3));
    B = p1(3) *(p2(1) - p3(1)) + p2(3) *(p3(1) - p1(1)) + p3(3) *(p1(1) - p2(1));
    C = p1(1) *(p2(2) - p3(2)) + p2(1) *(p3(2) - p1(2)) + p3(1) *(p1(2) - p2(2));
    D = (p1(1) *(p2(2)* p3(3) - p3(2)* p2(3)) + p2(1) *(p3(2) *p1(3) - p1(2)...
        *p3(3)) + p3(1) *(p1(2) *p2(3) - p2(2) *p1(3)));
    % since [0, 0, 0] should be below the plane,
    if D > 0
        D = -D;
        A = -A;
        B = -B;
        C = -C;
    end
    dsign = sign(D);
    len_normV = sqrt(A^2+B^2+C^2);
    dist_from_O_to_theplane = abs(D)/len_normV;
    new_dist = dist_from_O_to_theplane-shell_thickness;
    D = dsign*new_dist*len_normV;
    alleqn(i, :) = [A, B, C, D];
end

V = MY_con2vert(alleqn(:, 1:3),alleqn(:, 4));
ind = convhull(V(:,1), V(:,2), V(:,3));
vert = V(ind, :);
vert = unique_m(vert);
faces = findfaces(vert);
obj.vertices = vert + cm;
obj.faces = faces;
end