function pdb = PDB_atom2residue(pdb)
% convert PDB's Atom to N of electron based on the residue.
% It does not take HETATM into account.
% Byeongdu 2/29/2016
if ~isprop(pdb, 'resName')
    return
end
if ~isprop(pdb, 'atomName')
    return
end
if ~isprop(pdb, 'Atom')
    return
end
Natom = numel(pdb.atomName);
if Natom == 0
    return
end
%Ind_start_of_new_residue = [1, diff(resNum)];
[CA, isCA] = findcellstr(pdb.atomName, 'CA');
%CAresNum = resNum(CAindex);
FN = fieldnames(pdb);
for i=1:numel(FN)
    if numel(pdb.(FN{i})) == Natom
        pdb.(FN{i})(~isCA) = [];
    end
end

a = aminoacid;
for i=1:numel(CA)
    pdb.Atom(i) = a.Ne(pdb.resName{i});
end