function [Pq, r, pr] = PDBbox2Pq(q, pdbboxmodel)
if isa(pdbboxmodel, 'BOXmodel')
    p = pdbboxmodel;
    ed = p.Nelectrons(:);
    boxx = p.cpb{1};
    boxy = p.cpb{2};
    boxz = p.cpb{3};
    boxsize = p.resolution;
else
    error('This function PDBbox2Pq.m requires a BOXmodel class as an input')
end

resolution = 100;
if isempty(p.xbox)
    [X,Y,Z] = meshgrid(boxx, boxy, boxz);
    x = X(:);
    y = Y(:);
    z = Z(:);
    t = ed == 0;
    x(t) = [];
    y(t) = [];
    z(t) = [];
    ed(t) = [];
else
    x = p.xbox(:);
    y = p.ybox(:);
    z = p.zbox(:);
    if numel(x) ~= numel(ed)
        error('Check the BOXmodel. xbox and Nelectrons are not the same size')
    end
end
isneedtocomputepr = 1;
if isfield(p, 'r')
    if ~isempty(p.r)
        isneedtocomputepr = 0;
    end
end
if isneedtocomputepr
    [r, pr] = distNzero1([x, y, z], resolution, ed);
else
    r = p.r;
    pr = p.pr;
end
% gm=frcube2(r,boxsize);
% selfterm = pr2Iq(r, gm.*r.^2, q);selfterm = sum(ed.^2)*selfterm/boxsize^6;

% Pq = pr2Iq(r, pr, q);
selfterm2 = sum(ed.^2);
Pq = debyef0(q, r, pr)+selfterm2(:);
r = linspace(0, max(r)*1.5, 500);r = r';
pr = Iq2pr(q, Pq, r);