function [xx, y] = coord2eden(x, y, z, Numofelectron, code)
[sx, sy] = size(x);
[sNx, sNy] = size(Numofelectron);
if (sNx == sx)
    if ((sNy < sy) && (sNy == 1))
	Numofelectron = repmat(Numofelectron, 1, sy);
    end
end

switch code
    case {'r_xz'}
	r = sqrt(x.^2 + z.^2);
    otherwise
	r = sqrt(x.^2+y.^2+z.^2);
end

r = reshape(r, 1, numel(r));
Numofelectron = reshape(Numofelectron, 1, numel(Numofelectron));

xx = 0:max(max(r));
y = zeros(size(xx));
y(1) = sum(Numofelectron(r == 0));

for i=2:length(xx)
    t = (r>xx(i-1)) & (r<= xx(i));
    den = sum(Numofelectron(t));
    switch code
	case {'r_xz'}
	    div = pi*(xx(i)^2-xx(i-1)^2);
	otherwise
	    div = 4*pi/3*(xx(i)^3-xx(i-1)^3);
    end
    y(i) = den/div;
end
