function fq = fq_box(qx, qy, qz, obj, xyangle, yzangle)
% Calculate the SAXS form factor from boxmodel 
%
% Byeongdu Lee

if nargin <= 4
    xyangle = 0;
    yzangle = 0;
elseif nargin <=5
    yzangle = 0;
end

xt = qx;
yt = qy;

qx = cos(xyangle)*xt + sin(xyangle)*yt;
qy = -sin(xyangle)*xt + cos(xyangle)*yt;

% rotate pyramid 45degree in yz plane.
yt = qy;
zt = qz;

qy = cos(yzangle)*yt + sin(yzangle)*zt;
qz = -sin(yzangle)*yt + cos(yzangle)*zt;
        % ===============================================
j = sqrt(-1);
[nx, ny] = size(qx);
if nx>ny
    Q = [qx, qy, qz];
else
    Q = [qx', qy', qz'];
end
%q = sqrt(Q(:,1).^2+Q(:,2).^2+Q(:,3).^2);
if ndims(obj.Nelectrons) > 0
    obj = obj.removeEmptyBox;
end
ed = obj.Nelectrons(:)';
x = obj.xbox;
y = obj.ybox;
z = obj.zbox;
boxsize = obj.resolution;
R = [x, y, z];R = R';
%atm = ed;
atm = saxscube(qx,qy,qz,boxsize/2);
scale = atm*ed/boxsize^3;

%fq = zeros(size(qx));      
fq = sum(scale.*exp(-j*Q*R),2);
%for i=1:numel(x);
%    fq = fq+atm(i)*exp(-j*(qx*x(i)+qy*y(i)+qz*z(i)));
%end