function t = pdb_write(filename, pdb)
% pbd is a pdb class

fid = fopen(filename, 'w');

for i=1:numel(pdb.atomNum)
if ~isprop(pdb, 'atomName')
    Name = 'NA';
else
    Name = pdb.atomName{i};
end
if ~isprop(pdb, 'LocationInd')
    LI = ' ';
else
    LI = pdb.LocationInd(i);
end
if ~isprop(pdb, 'ResidueName')
    RN = 'VAL';
else
    RN = pdb.ResidueName(i);
end
if ~isprop(pdb, 'ChainIdn')
    CI = 'A';
else
    CI = pdb.ChainIdn(i);
end
if ~isprop(pdb, 'ResSeqNumber')
    RSN = 1;
else
    RSN = pdb.ResSeqNumber(i);
end
if ~isprop(pdb, 'Code')
    C = ' ';
else
    C = pdb.Code(i);
end
if ~isprop(pdb, 'Occupancy')
    Oc = 1;
else
    Oc = pdb.Occupancy(i);
end
if ~isprop(pdb, 'Tfactor')
    Tf = 0;
else
    Tf = pdb.Tfactor(i);
end
%if ~isprop(pdb, 'SegIdn')
%    SI = ' ';
%else
%    SI = pdb(i).SeqIdn;
%end
if ~isprop(pdb, 'ElementSymbol')
    ES = 'C';
else
    ES = pdb.ElementSymbol(i);
end
if ~isprop(pdb, 'Charge')
    CG = ' ';
else
    CG = pdb.Charge(i);
end

X = pdb.X(i);
Y = pdb.Y(i);
Z = pdb.Z(i);

str = sprintf('%6s%5i%4s%1s%3s%1s%1s%4i%1s%3s%8.3f%8.3f%8.3f%6.2f%6.2f%10s%2s%2s','ATOM  ', i, ...
    Name, LI, RN, CI, ' ', RSN, C, '   ', X, Y, Z, Oc, Tf, '          ', ES, CG);
fprintf(fid, '%s\n', str);
end

t = fclose(fid);   