function [atom, x, y, z, matrix, Tmat] = pdbread2(filename)
atom = [];
x = [];
y = [];
z = [];
fid = fopen(filename, 'rt');
if (fid<0)
        error(['Couldn''t find ' file]);
end
matrix = zeros(3, 3, 1);
Tmat = zeros(3, 1);
line = fgetl(fid);

while line~=-1
    head = strtok(line, ' ');
    if strcmp(head,'ATOM')
	[a, num, atmtype, res, arbnum, resnum, xn, yn, zn, num1, num2, atm]=sscanf(line, '%s %i %s %s %s %i %f %f %f %f %f %s', 'C');
	switch atm
	   case 'C'
		atomn = 6;		
	   case 'N'
		atomn = 7;
 	   case 'O'
		atomn = 8;
	   case 'S'
		atomn = 16;
	   otherwise
		error('invalid atomic type');
    end
   	atom = [atom;atomn];
	x = [x;xn];
	y = [y;yn];
	z = [z;zn];
   elseif strcmp(head, 'MODEL')
%	[a, num] = sscanf(line, '%s %i', 'C');
%	num
%	fflush(1);
   elseif strcmp(head, 'MTRIX1') || strcmp(head, 'MTRIX2') || strcmp(head, 'MTRIX3')
%	[a, b, xn, yn, zn, tr] = sscanf(line, '%s %i %f %f %f %f', 'C'); % octave
%	matrix(1, :, b) = [xn, yn, zn];
%	Tmat(1, b) = tr;
        
        str = strread(line, '%s'); % octave
        matrix(str2double(str{1}(end)), :, b) = [str2double(str{3}), str2double(str{4}), str2double(str{5})];
        Tmat(str2double(str{1}(end)), str2double(str{2})) = str2double(str{6});
   end 
        line=fgetl(fid);
end
[sx, sy, sz] = size(matrix);
subset_atom = [x';y';z'];
numofatom = length(x);
for i=1:sz
    t = matrix(:,:,i)*subset_atom + repmat(Tmat(:, i), 1, numofatom);
%    if i>1
    	x = [x, t(1,:)'];
    	y = [y, t(2,:)'];
    	z = [z, t(3,:)'];
%    else
%	x = t(1, :)';
%	y = t(2, :)';
%	z = t(3, :)';
 %   end
end
fclose(fid);
