function t = pdbwrite(filename, atom)
% atom : Name, LocationIndicator, ResidueName, ChainIdentifier,
% ResidueSequenceNumber, Code, X, Y, Z, Occupancy, Tfactor, SegIdentifier,
% ElementSymbol, Charge
if isa(atom, 'PDB')
    pdb_write(filename, atom)
    return
end
fid = fopen(filename, 'w');

for i=1:numel(atom)
if ~isfield(atom, 'Name')
    Name = 'NA';
else
    Name = atom(i).Name;
end
if ~isfield(atom, 'LocationInd')
    LI = ' ';
else
    LI = atom(i).LocationInd;
end
if ~isfield(atom, 'ResidueName')
    RN = 'VAL';
else
    RN = atom(i).ResidueName;
end
if ~isfield(atom, 'ChainIdn')
    CI = 'A';
else
    CI = atom(i).ChainIdn;
end
if ~isfield(atom, 'ResSeqNumber')
    RSN = 1;
else
    RSN = atom(i).ResSeqNumber;
end
if ~isfield(atom, 'Code')
    C = ' ';
else
    C = atom(i).Code;
end
if ~isfield(atom, 'Occupancy')
    Oc = 1;
else
    Oc = atom(i).Occupancy;
end
if ~isfield(atom, 'Tfactor')
    Tf = 0;
else
    Tf = atom(i).Tfactor;
end
%if ~isfield(atom, 'SegIdn')
%    SI = ' ';
%else
%    SI = atom(i).SeqIdn;
%end
if ~isfield(atom, 'ElementSymbol')
    ES = 'C';
else
    ES = atom(i).ElementSymbol;
end
if ~isfield(atom, 'Charge')
    CG = ' ';
else
    CG = atom(i).Charge;
end

X = atom(i).X;
Y = atom(i).Y;
Z = atom(i).Z;

str = sprintf('%6s%5i%4s%1s%3s%1s%1s%4i%1s%3s%8.3f%8.3f%8.3f%6.2f%6.2f%10s%2s%2s','ATOM  ', i, ...
    Name, LI, RN, CI, ' ', RSN, C, '   ', X, Y, Z, Oc, Tf, '          ', ES, CG);
fprintf(fid, '%s\n', str);
end

t = fclose(fid);   