function [y, name, pnames, pin] = AgBHFitting(x, p, flag)
% this is for AgBH GISAXS peak fitting
% numeric OrgData is fitting function
%   fitting the shifts of x axis and scales.
% p = [xshift1, Amp1, xshift2, Amp2, background]

if nargin == 2
    
    xsh1 = p(1);
    m1 = p(2);
    xsh2 = p(3);
    m2 = p(4);
    sig1 = p(5);
    sig2 = p(6);
    bkg = p(7);

    global OrgData

%    y1 = spline(OrgData(:,1), OrgData(:,2), x);
    y1 = spline((OrgData(:,1) + xsh1)*sig1, OrgData(:,2), x);
    y2 = spline((OrgData(:,1)+ xsh2)*sig2, OrgData(:,2), x);
    y = m1*y1 + m2*y2 + bkg;
    
else
    
   DSC=[];
   name='AgBH Peak fitting';
   
    pnames=str2mat('xshift1', 'Amp1', 'xshift2', 'Amp2', 'sig1', 'sig2', 'background');
	if flag==1, pin=[0, 1, 0, 1, 1, 1, 0]; else pin = p; end
   
end       