function [Fq, name, pnames, pin] = EdenFq3(q, p, flag)
% q is scattering vector
% p is parameter
% model : centrosymmetric particle
%    model electron density to intensity
% p = [a, c1, c2, .... cn];
% a : width of step function
% c : e-density of the each step function
% n : number of step function
% Jan. 25, 06
% p = [eden, zin, sig] ex, p = [0, 0.5, 1, 0, 80, 10, 5, 5, 5, 5];

%s.eden = [0, 0.5, 1, 0];
%s.zin = [80, 10, 5];  %biggest number should be first.
%s.sig = [5, 5, 5];

if nargin == 2;
    numpnt = (length(p)-2)/3;
%    s.eden = p(1:(numpnt+1));
%    s.zin = p((numpnt+2):(numpnt*2+1));
%    s.sig = p((numpnt*2+2):numpnt*3+1);
%    zend = (s.zin(1) + s.sig(1)*3);
%    zz = 0:zend/50:zend;
%    zp = zprofile(zz, s.eden, s.zin, s.sig);
zz = abs(p((numpnt+2):(numpnt*2+1)));
zp = abs(p(1:(numpnt+1)));
    Fq = zeros(size(q));
    nomal = 0;q = q+eps;
    qn = q;
Iq = zeros(size(Fq));
zz=fliplr(zz);
zp=fliplr(zp);
for b=0:1:179
    q = qn*sin(b*pi/180);nomal=0;
    for i=1:(length(zp)-1)
        Rj = zz(i);
        Fq = Fq + (zp(i)-zp(i+1))*(Rj)*besselj(1, (q+eps)*Rj)./(q+eps);
        nomal = nomal + (zp(i)-zp(i+1))*(Rj)^2;
    end

    Fq = Fq./nomal;

%for b=0:10:180
    Iq = Iq + abs(Fq.*sinc(qn*2000*cos(b*pi/180))).^2;
end
Fq = Iq/180;
Fq = p(end)*Fq;

name='Concentric Ring';
pnames=str2mat('eden1', 'eden2', 'eden3', 'eden4', 'eden5', 'int1', 'int2', 'int3', 'int4', 'rough1', 'rough2', 'rough3', 'rough4', 'I0');
pin = [];
else
	y = [];
	name='Concentric Ring';
	pnames=str2mat('eden1', 'eden2', 'eden3', 'eden4', 'eden5', 'int1', 'int2', 'int3', 'int4', 'rough1', 'rough2', 'rough3', 'rough4', 'I0');
	if flag==1, pin=[0, 1, 2, 1, 0, 80, 20, 10, 5, 0, 0, 0, 0, 100]; else pin = p; end
end


