function [Formfactor, name, pnames, pin] = Ellips(q, p, flag)
% Ellipsoid of revolution
% This expression was determined by Guinier 
% q is scattering vector
% p is input parameter
%   [R, epsilon, I0]

if nargin==2;
    R = p(1);
    epsilon = p(2);
    I0 = p(3);
    
    alpha = 0:pi/50:pi/2;
    
    r = R*sqrt(sin(alpha).^2 + epsilon^2*cos(alpha).^2);
    P = spheretype(q, r)*sin(alpha)';
    P = sum(P,2);
    Formfactor = P/P(1)*I0;
    
else
    
   Formfactor=[];
   name='Ellipsoid of revolution';
    pnames=str2mat('R','epsilon','I0');
	if flag==1 
        pin=[10 1 1];
    else 
        Rg = 1/sqrt(5)*sqrt(2+p(2).^2)*p(1);
        sprintf('Rg is %7.2f', Rg)
        pin = p; 
    end
   
end   