function f = GIhalfEllipFF(qp, qz, Rp, Rz, H)
% half ellipsoid
% f = GIhalfEllipFF(qp, qz, Rp, Rz, H)


if H>2*Rz
	disp('H should be less than 2*Rz')
	fflush(1)
end
dz = Rz/30;
z = 0:dz:H;
[Qp, Qz] = meshgrid(qp, qz);
f = zeros(size(Qp));
for z=0:dz:H
	Rc = sqrt(Rz^2-(z-H+Rz)^2)*Rp/Rz;
	qin = Qp*Rc;
	f = f + 2*pi*Rc^2*besseljc(qin).*exp(-j*Qz*z)*dz;
end
