function [Formfactor, name, pnames, pin] = corn_vert_type2(qpa, qper, p, flag)
% this is Amplitude for cylinder type particle : cylindertype2(qp, qz, p)
% cylinder is assumed to normal to surface.
% p = [R, H, alpha, I0] 
% 2004. Feb, 4
global qp qz R H alpha
qp = qpa;
qz = qper;
R = p(1);
H = p(2);
alpha = p(3);
I0 = p(4);
if (prod(size(qp)) == 1) & (prod(size(qz)) == 1)
        Formfactor = quad(@myfun, 0, H);
elseif (prod(size(qp)) > 1) & (prod(size(qz)) == 1)
    for i=1:length(qp)
        qp = qpa(i);
        Formfactor(i) = quad(@myfun, 0, H);
    end
elseif (prod(size(qp)) == 1) & (prod(size(qz)) > 1)
    for i=1:length(qz)
        qz = qper(i);
        Formfactor(i) = quad(@myfun, 0, H);
    end
elseif (prod(size(qp)) > 1) & (prod(size(qz)) > 1)
    [qpp, qzz] = meshgrid(qpa, qper);
    for i=1:prod(size(qpp))
        qp = qpp(i);
        qz = qzz(i);
        Formfactor(i) = quad(@myfun, 0, H);
    end
    Formfactor = reshape(Formfactor, size(qpp));
end

function y = myfun(z)
global qp qz R alpha
Rz = R-z./tan(deg2rad(alpha));
%qp = ones(size(Rz))*qp;
%qz = ones(size(Rz))*qz;
y = 2*pi*Rz.^2.*besselj(1, qp.*Rz)./(qp.*Rz).*exp(-j.*qz.*z);