function [F1, F3] = cylinder_parall_type(qx, qy, qz, Rsp, RLratio, inplaneang)
% cylinder_parall_type(qx, qy, qz, Rsp, RLratio, inplaneang)
% qx, qy, qz all should be vector.
% 
    ang = inplaneang*pi/180;
    cylinderDirec = [1 0 0];
    Rotm = [cos(ang), sin(ang), 0;-sin(ang), cos(ang), 0; 0, 0, 0];
    cylinderDirec = Rotm*cylinderDirec';
    [sr, sc] = size(qz);
    if sc == 2
        [dimx, dimy]=size(qz);
        q1z = qz(:,1:end/2);q3z = qz(:,(end/2+1):end);
        beta1 = angle2vectmat(qx, qy, q1z, cylinderDirec);
        beta3 = angle2vectmat(qx, qy, q3z, cylinderDirec);
        q1 = sqrt(qx.^2 + qy.^2 + q1z.^2);
        q3 = sqrt(qx.^2 + qy.^2 + q3z.^2);
        [F1, avFq2_1, av2Fq_1] = orientCylinder(q1, beta1, Rsp, RLratio,0,0);
        [F3, avFq2_3, av2Fq_3] = orientCylinder(q3, beta3, Rsp, RLratio,0,0);
%        F = [F1, F3];
    else
        q1z = qz;q3z = 0;
        beta1 = angle2vectmat(qx, qy, q1z, cylinderDirec);
        q1 = sqrt(qx.^2 + qy.^2 + q1z.^2);
        [F1, avFq2_1, av2Fq_1] = orientCylinder(q1, beta1, Rsp, RLratio,0,0);
 %       F = F1;
    end
