function [Formfactor, name, pnames, pin] = cylindertype2(q, p, flag)
% this is for cylinder type particle : cylindertype(q, p)
% p = [R, L] 
% code copied from Igor IPNS SAXS.

[xq, yq] = size(q);

if xq < yq 
    q = q';     % q should be column vector
end

if nargin == 2
    
    R = p(1);
    L = p(2);
    prec = 512;
    qr = q*R;
    ql = q*L;
    del = ql/prec;
    fcs = 2*besseljc(qr);
    x = del/2;
    fl = zeros(size(q));
    for i=1:length(q)
        while (x(i)<ql(i))
            fl(i) = fl(i) + sinc(1/pi*x(i));
            x(i) = x(i) + del(i);
        end
    end
    fl = fl.*del./ql - sinc(1/pi*ql*2).^2;
    fs = (fcs.^2).*fl;
    Formfactor = fs;
else
    
   Formfactor=[];
   name='Cylinder Model';
   
    pnames=str2mat('R','dR', 'HoverR','type','I0');
	if flag==1, pin=[10 0.1 2 0 1]; else pin = p; end
end       