function Fq = diazc(varargin)
warning off;
if numel(varargin) == 5
    qx = varargin{1};
    qy = varargin{2};
    qz = varargin{3};
    shape = varargin{4};
    L = varargin{5};
    a = polyhedra(shape, L);
    a = polyhedron_facecheck(a);
elseif numel(varargin) == 4
    % assuming polyhedron_facecheck is done.
    qx = varargin{1};
    qy = varargin{2};
    qz = varargin{3};
    a = varargin{4};
end
q = [qx(:), qy(:), qz(:)];
%qn = vectorNorm3d(q)';
q = q';

% tic
%     a = polyhedron_facecheck(a);    
% toc
faces = a.faces;
vertices = a.vertices;
%Fq = zeros(1, numel(qx));
j = sqrt(-1);
if iscell(faces)
    Nfaces = numel(faces);
    nvert_face = cellfun(@numel, faces);
    for i=1:numel(faces); 
        if size(faces{i}, 2)>1; 
            faces{i} = faces{i}'; 
        end; 
    end
    allfaces = cell2mat(faces);
else
    Nfaces = numel(faces(:, 1));
    nvert_face = ones(size(faces, 1), 1)*size(faces,2);
    allfaces = faces;
    allfaces = allfaces';
    allfaces = allfaces(:);
end
allfaces = allfaces - 1;% c array start from 0 instead of 1..
allvertices = vertices';
facenormal = a.faceNorm';

Fq = diaz_(Nfaces, nvert_face, facenormal, allfaces, allvertices, q);
Fq = Fq(:)/j;
warning on;

end