function [y, name, pnames, pin]  = doublecyl(qz, par, flag)
% par = r1, r2, h1, h2
if nargin == 2;
    qp = par(1);
    r1 = par(2);
    r2 = par(3);
    h1 = par(4);
    h2 = par(5);
    I0 = par(6);
    bkg = par(7);
    D = (h1+h2)/2;
    y = I0*abs(2*pi*(r1^2*h1*besselj(1, qp.*r1)./(qp.*r1).*sinc(qz*h1/2/pi) +...
        r2^2*h2*besselj(1, qp.*r2)./(qp.*r2).*sinc(qz*h2/2/pi).*exp(-j*qz*D))).^2 + bkg;
else
	y=[];
	name='two cylinder';
	pnames=str2mat('qp','r1', 'r2', 'h1', 'h2', 'I0','bkg');
	if flag==1, pin=[0.01, 10, 10, 10, 10, 1, 0]; else pin = p; end
end
