function [fq, avFq2] = hollowCylinderForm2(qr, R, rho,sig)
% Formfactor of hollow cylinder2
% [fq, avFq2] = hollowCylinderForm2(qr, R, rho)
% currently, only fq are calculated, avFq2 = abs(fq).^2;
% L. Ramos et al. Eur. Phys. J. B 1, 319(1998)
n = length(rho);
sumBottom = 0;
for i=1:n-1
    sumBottom = sumBottom + (rho(i) - rho(i+1))*R(i)^2;
end

fq = zeros(size(qr));
for i=1:n-1
    fq = fq + (rho(i) - rho(i+1))*R(i)^2*besseljc(qr*R(i));
end

%fq = 2./qr.*fq/sumBottom;
fq = 2*fq/sumBottom;
if sig>0
    w = gauss(1:500, [1, 250, sig, 0]);
    %w = normpdf(1:100, 50, sig);
    avFq2 = convlv(abs(fq).^2, w)/sum(w);
else
    avFq2 = abs(fq).^2;
end