function [Y, name, pnames, pin] = hollowCylinderForm3Amp(q, p, flag)
% Formfactor of hollow cylinder3
% [P, name, pnames, pin] = hollowCylinderForm3(q, p, flag)
% currently, only fq are calculated
%    Rout = p(1);
%    Rin1 = p(2);
%    Rin2 = p(3);    
%    rho1 = p(4);
%    rho2 = p(5);
%    rho3 = p(6);
%    I0 = p(7);

% L. Ramos et al. Eur. Phys. J. B 1, 319(1998)
%n = length(rho);
%sumBottom = 0;
%for i=1:n-1
%    sumBottom = sumBottom + (rho(i) - rho(i+1))*R(i)^2;
%end

[xq, yq] = size(q);

if xq < yq 
    q = q';     % q should be column vector
end

if nargin == 2
    
    Rout = abs(p(1));
    Rin1 = abs(p(2));
    Rin2 = abs(p(3));

    rho1 = p(4);
    rho2 = p(5);
    rho3 = p(6);
    I0 = p(7);

    rho4 = 0;
    
    Y = zeros(size(q));
%        R = [Rin2, Rin1all(j), Routall(j)];
        % ========
        R = [Rin2, Rin1, Rout];
        % =============
        rho = [rho1, rho2, rho3, rho4];
        
        fq = 0;L=3000;
        for i=1:length(R)
            fq = fq + 2*pi*L*(rho(i) - rho(i+1))*R(i)^2*besseljc(q*R(i));
        end
        Y = fq;
else
    
   Y=[];
   name='Hollow Cylinder Model';
   
    pnames=str2mat('Rout', 'Rin1', 'Rin2', 'rho1', 'rho2', 'rho3', 'I0');
	if flag==1, pin=[83, 50, 20, 0, 1, 0.5, 1]; else pin = p; end
end           