function [y, name, pnames, pin] = lognDistSphere(x, p, flag)

if nargin == 2;
    mu = p(1);
    sig  = p(2);
    I0 = p(3);
    Bg = p(4);
    
    xx = 0.1:0.1:1000;

    if sig > 0
        logno = lognpdf(xx, mu, sig)';
        cutoff = find(logno < 0.03*max(logno));
    else
        logno = lognpdf(xx, mu, 1)'*0;
        cutoff = find(logno < 0.03*max(logno));
    end    
    logno(cutoff) = [];
    xx(cutoff) = [];
    
%    z = xx.*logno';
%    avgv = sum(z)/sum(logno);ttemp = ['Average radius is  ', num2str(avgv)];
%    disp(ttemp);

     [x1, x2]= size(x);
    [LN, X] = meshgrid(logno, x);
    [XX, X] = meshgrid(xx, x);
    
    if x1 < x2
        x = x';
    end

%    y = spheretype(x, xx).*(LN.*XX.^6);    % number distribution
%    normFactor = sum(LN.*XX.^6, 2);normFactor = normFactor(1);
y = spheretype(x, xx).*(LN.*XX.^3);   % volume distribution 
normFactor = sum(LN.*XX.^3, 2);normFactor = normFactor(1);
    y = sum(y, 2)*I0/normFactor + Bg;
else
	y=[];
	name='Lognormal distr Sphere';
	pnames=str2mat('mu','sig','I0','bkg');
	if flag==1, pin=[1 1 100 0]; else pin = p; end
	if flag==2
		mu = input('mu ?')
        sig = input('sig ?')
        I0 = input('sig ?')
        Bg = input('bkg ?');
		pin=[mu sig I0, Bg];
	end
end