function a = polyhedron_facecheck(a)
% calculate facenormal vector and if it face inward, flip it to face out.
% required to use diazc.m
    faces = a.faces;
    vertices = a.vertices;
    Nfaces = numel(faces(:, 1));
    faceNorm = [];
    cm = [];
    ngb_faces = {};
    ngb_manyfaces = [];
    mf = 1;
    for i=1:Nfaces
        %ngb_face = [];
        f1 = faces(i, :);
        cm_k = mean(vertices(f1, :));
        fv = vertices(f1, :);
        n1 = planeNormal([fv(1, :), ...
            fv(2, :)-fv(1, :),...
            fv(3, :)-fv(1, :)]);
        n1 = n1/vectorNorm3d(n1);
        out = inPolyhedron2(a, cm_k + n1);
        %in = inPolyhedron2(a, cm_k - n1);
        %T = T/vectorNorm3d(T);
%         if (out~=0) 
%             faces(i,:) = fliplr(faces(i, :));
%             n1 = -n1;
%         end

        N_vertices_for_face1 = numel(f1);
        ngb_face = zeros(size(f1));
        for v_indx = 1:N_vertices_for_face1
            if v_indx < N_vertices_for_face1
                v_pair = [v_indx, v_indx+1];
            else
                v_pair = [v_indx, 1];
            end
            [~, f_indx2] = find_neighbor_face(i, f1(v_pair), faces);
            if numel(f_indx2)>2
                fprintf('More than two faces share the edge made of %i and %i vertices\n', f1(v_pair(1)), f1(v_pair(2)))
                ngb_manyfaces = [ngb_manyfaces, f_indx2];
                mf = mf+1;
            else
                ngb_face(v_indx) = f_indx2;
            end
        end
        %ngb_faces{i} = ngb_face;
        faceNorm(i, :) = n1;
        cm(i,:) = cm_k;
    end
    a.faces = faces;
    %a.ngb_faces = ngb_faces;
    a.faceNorm = faceNorm;
    a.cm = cm;
end
    function [vn_NF, face_index] = find_neighbor_face(f1, vn, faces)
        % f1 : face number
        % vn : shared vertices, ex. [1,3]
        % vn_NF : vertices indices of the neighboring face. 
        N = 1:size(faces, 1);
        N(f1) = [];
        faces(f1, :) = [];
        ind = sum(ismember(faces, vn), 2) == 2;
        vn_NF = faces(ind, :);
        face_index = N(ind);
%         if sum(ind)>1
%             ind
%         end
    end