function [F, V, Rmat, Rmatfaces, Rmatvertices, tri_tet] = saxsicosahedron( qx, qy, qz, L)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here

%a = 2;
V = 10*(3+sqrt(5))/3*(L/2)^3;

p = (1+sqrt(5))/2;
H = sqrt(p^2+(1+2*p)^2)/3;
edgeL = 2;
tH = 3*H;
t = 2*sqrt(3);
Rmat{1} = [0,1,0; -p/sqrt(3), 0, (1-p)/sqrt(3); p/tH, 0, -(2*p+1)/tH];
Rmat{2} = [p/2, 1/2, (p-1)/2;(p-2)/t, (2*p-1)/t, -(p+1)/t;(p+1)/tH, -(p+1)/tH, -(p+1)/tH];
Rmat{3} = [1/2, -(p-1)/2, p/2; sqrt(3)/2, (p-1)/t, -p/t; 0, -(2*p+1)/tH, -p/tH];
Rmat{4} = [-1/2, -(p-1)/2, p/2;(2*p-1)/t, -(p+1)/t, -(p-2)/t;-(p+1)/tH, -(p+1)/tH, -(p+1)/tH];
Rmat{5} = [-p/2, 1/2, (p-1)/2;-p/t, -sqrt(3)/2, (p-1)/t;-p/tH, 0, -(2*p+1)/tH];
Rmat{6} = [0,0,-1;(p-1)/sqrt(3), -p/sqrt(3),0;(2*p+1)/tH, p/tH, 0];
Rmat{7} = [-(p-1)/2, p/2, 1/2;(p+1)/t, (p-2)/t, (2*p-1)/t;(p+1)/tH, (p+1)/tH, -(p+1)/tH];
Rmat{8} = [-1/2, -(p-1)/2, -p/2;sqrt(3)/2, -(p-1)/t, -p/t;0, (2*p+1)/tH, -p/tH];
Rmat{9} = [-1/2, (p-1)/2, p/2; (2*p-1)/t, (p+1)/t, -(p-2)/t; -(p+1)/tH, (p+1)/tH, -(p+1)/tH];
Rmat{10} = [-(p-1)/2, -p/2, -1/2;(p-1)/t, p/t, -sqrt(3)/2;-(2*p+1)/tH, p/tH, 0];
H = H/edgeL*L;

sizeqx = size(qx);
Qall = [qx(:), qy(:), qz(:)]';
F = zeros(size(Qall(1,:)));

for i=1:numel(Rmat);
    invM = Rmat{i};
    Q = invM*Qall;
    F = F + 2*real(saxsTet(Q(1,:), Q(2,:), Q(3,:), [L, H]));
    %M =inv(invM);   % for particle transform.
    %temp = M*tri_tet';
    %temp = temp';
    %plot3(temp(:,1), temp(:,2), temp(:,3), 'ro')
    %patch(temp(:,1), temp(:,2), temp(:,3), 'r')
end
F = reshape(F, sizeqx);

function F = saxsTet(qx, qy, qz, LH)
    j = sqrt(-1);
    R = LH(1)/2;
    F = saxstetrahedron2(qx, qy, qz, LH);
    F = F.*exp(j*qz*LH(2));% shift to -qz direction by LH(2)
end
end
