function F = saxsoctahedron3(qx, qy, qz, L)
R = L/sqrt(2);
H = R;
F = zeros(size(qx));
for i=0:3
    M = [cos(pi/2*i),sin(pi/2*i),0;-sin(pi/2*i),cos(pi/2*i),0;0,0,1];
    q1 = M(1,1)*qx + M(1,2)*qy;
    q2 = M(2,1)*qx + M(2,2)*qy;
    F1 = saxsoctant2(q1, q2, qz, [R, L, H]);
    F2 = saxsoctant2(q1, q2, -qz, [R, L, H]);
    F = F+F1+F2;
end
%F = F;