function ysum = saxspolydisperse(q, y, originalR, dr, newq)
% ysum = saxspolydisperse(q, y, originalR, dr, newq)
% in this case the unit of dr is indentical to that of originalR;
% gaussian distribution where dr is the width.
%
%
% B. Lee
x = linspace(originalR-dr*3, originalR+dr*3, 11);
[x, nr] = gaus(x, originalR, dr);
ysum = 0;
for m=1:numel(nr)
    qn = q/(1+x(m)/originalR);
    if nargin > 3
        yn = interp1(qn, y, newq);
        yn(isnan(yn)) = 0;
    else
        yn = interp1(qn, y, q);
    end
    ysum = ysum + nr(m)*yn*(x(m)/originalR)^6;
end
ysum = ysum/sum(nr);