function [Formfactor, name, pnames, pin] = sphere_vert_type(qp, qz, p, flag)
% this is Amplitude for cylinder type particle : cylindertype(qp, qz, p)
% cylinder is assumed to normal to surface.
% qp could be vector
% qz should be just point(one value)
% or either qp or qz should be point value.....
% p = [R, L, I0) 
% 2004. Feb, 4

qp = real(qp);qz = real(qz);

if length(qp) > length(qz)
    qq = qp;
else
    qq = qz;
end

[xq, yq] = size(qq);

if xq < yq 
    qp = qp';     % q should be column vector
    qz = qz';
    qq = qq';
end

    R = p(1);
    H = p(2);
    I0 = p(3);
    
    z = H/50:H/50:(H-H/50);
    dz = H/50;

    oneq = ones(size(qq));
    onez = ones(size(z));
    z = oneq*z;
    R = ones(size(z)).*R;
    H = ones(size(z)).*H;

    if prod(size(qp)) == 1
        qp = qp.*ones(size(z));        
    elseif prod(size(qp)) == prod(size(qq))
        qp = qp*onez;
    end
    if prod(size(qz)) == 1
        qz = qz.*ones(size(z));        
    elseif prod(size(qz)) == prod(size(qq))
        qz = qz*onez;
    end
    x = abs(z - H + R);
    Rz = sqrt(R.^2 - x.^2);
    
    F = zeros(size(z));
    qpRz = qp.*Rz;
    [xzero, yzero] = find(qpRz == 0);qpRz(xzero, yzero) = 0.0001;
    F = 2*pi*Rz.^2.*bessel(1, qpRz)./(qpRz).*exp(j.*qz.*z)*dz;
    F = sum(F, 2);F = F.*exp(j.*qz(:,1).*(H(1,1)-R(1,1)));F = abs(F).^2;
    Formfactor = F*I0;