function F = tetrahedron_croset(qx, qy, qz, RH)
R = RH(1);
H = RH(2);
tri_tet = [
        1  -1/sqrt(3)  0
      -1 -1/sqrt(3) 0
      0 2/sqrt(3)  0 ];
A0 = [0, 0, H];
A = tri_tet*R;
j = sqrt(-1);
ind = [3,1,2,3,1];
F1 = zeros(size(qx));
F2 = zeros(size(qx));
Q = [qx(:), qy(:), qz(:)];
NQ = size(Q, 1);
for i=1:3
    AiA0 = repmat(A0 - A(i,:), NQ, 1);
    % i+1 --> rem(i-1, 3) + 1;
    Aip1Ai = repmat(A(i, :)-A(ind(i+2), :), NQ, 1);
    % i-1 --> 
    Ai_1Ai = repmat(A(i, :)-A(ind(i), :), NQ, 1);
    top = dot(AiA0, cross(Aip1Ai, Ai_1Ai, 2), 2);
    bott = dot(Q, Aip1Ai, 2).*dot(Q, Ai_1Ai, 2).*dot(Q, -AiA0, 2);
    F1 = F1 + top./bott.*exp(-j*dot(Q, repmat(A(i, :), NQ, 1), 2));
    F2 = F2 + top./bott;
end
F = j*F1-j*exp(-j*dot(Q, repmat(A0, NQ, 1), 2)).*F2;