function Inten = Lhkl(q, qhkl, w, v)
% Inten = Lhkl(q, qhkl, w, v)
% ref. Forster, J.P.C, 2005
% Peak shaping function
% Area is normalized to 1
if v < 0.001
    Inten = lorza(q, [1, qhkl, w/2, 0]);
elseif v > 100
    Inten = gaussa(q, [1, qhkl, sqrt(pi/8)*w, 0]);
else
    gv = sqrt(pi)*gamma((v+1)/2)/gamma(v/2);
    y = 4*(q-qhkl).^2/pi^2/w^2;
    Inten = ones(size(q));
    for n=0:1000
        Inten = Inten./(1+gv^2/(n+v/2)^2*y);
    end
    Inten = Inten*2/pi/w;
end