function Inten = fhkl(h,k,l, lattice)
% ref. Forster, J.P.C, 2005
% Peak shaping function
switch lattice
case 'LAM'
    Inten = 1;
case 'HEX'
    Inten = 1;
case 'SQ'
    Inten = 1;
case 'BCC'
    if mod(h+k+l, 2)==0
        Inten = 2;
    else
        Inten = 0;
    end
case 'FCC'
    if (mod(h, 2) == mod(k, 2)) & (mod(k, 2) == mod(l, 2))
        Inten = 4;
    else
        Inten = 0;
    end
case 'BCC'
    if (mod(h+k+l, 2) == 0)
        Inten = 4;
    else
        Inten = 0;
    end
case 'HCP'
    t = mod(h + 2*k, 3);
    tl = mod(l,2);
    if (t == 0) & (tl == 0)
        Inten = 2;
    elseif (t ~= 0) & (tl == 1)
        Inten = sqrt(3);
    elseif (t ~= 0) & (tl == 0)
        Inten = 1;
    else
        Inten = 0;
    end
case 'HPL' %Hexagonal ABC type
    t = mod(k+l-h, 3);
    if (t == 0)
        Inten = 3;
    else
        Inten = 0;
    end
end