function Sq = integCorr_qxyavg(qx, qz1, qz2, sig1, sig2, zint1, zint2, hcor, vcor, H)
qx = real(qx);
Sq = qx;
global xb;
global yb;

if length(qx) == length(qz1)
    Sq = corr_qxy(qx, qz1, qz2, sig1, sig2, zint1, zint2, hcor, vcor, H);
%    Sq = corr_qxy2(xb, yb, qx, qz1, qz2, sig1, sig2, zint1, zint2, hcor, vcor, H);
else % when dimensions of qx and qz1 are different, dim of qz1 should be always 1,
     % which means, on the other hands, dims of qx and qz1 are the same,
     % whenever dim of af or ai is bigger than 0 D and so is dim of tthi or tthf...
    [nx, ny] = size(qx);
    if ny > nx
        qzz1 = repmat(qz1, 1, ny);
        qzz2 = repmat(qz2, 1, ny);
    else
        qzz1 = repmat(qz1, nx, 1);
        qzz2 = repmat(qz2, nx, 1);
    end
    qx = reshape(qx, 1, nx*ny);
    qzz1 = reshape(qzz1, 1, nx*ny);
    qzz2 = reshape(qzz2, 1, nx*ny);
    Sq = corr_qxy(qx, qzz1, qzz2, sig1, sig2, zint1, zint2, hcor, vcor, H);
%    Sq = corr_qxy2(xb, yb, qx, qzz1, qzz2, sig1, sig2, zint1, zint2, hcor, vcor, H);
    Sq = reshape(Sq, nx, ny);
end    

function original
    y = 0.001;
    rmax = hcor*exp(log(log(1/y))/2/H);
    rr = 0:rmax/10000:rmax;
    dr = rmax/10000;
    for i=1:prod(size(qx))
%        if (qx(i)<0.001)
%            r_stp = 1000;
%        else
%            r_stp = 2*pi/(qx(i)+eps)/10;
%        end
%        rr = 0:r_stp:rmax;
%        dr = r_stp;

        t = abs(zint1-zint2)/vcor;
        Cr = sig1*sig2*exp(-(rr/hcor).^(2*H)-t);
        Cr = (exp((qz1.*qz2).*Cr)-1).*rr.*besselj(0,qx(i).*rr);
        Sq(i) = trapz(Cr)*dr; 
        sprintf('qx*dr = %f, dr = %f, rmax = %f, lenrr = %f\n',qx(i)*dr, dr, rmax,length(rr))
    end
