function Sq = strfactor_2Dyukawa(varargin)
% structure factor for 2D paracrystal, positional disorder is described with gaussian function
%
% Ref : J. Phys.:Condens. Mater 9(1997) L125-L130. Printed in the UK.
% p = [sigma of gaussian, Dspacing];
if isempty(varargin)
    Sq = {'Z1', 0.51, 0, 1.2, 0;...
        'Z2', 0.9, 0, 1.2, 0;...
        'K1', 0.33, 0, 1.2, 0;...
        'K2', -0.9, -5, 0, 0;...
        'volf', 0.1, 0, 0.3, 0;...
        'R', 30,10,60,0};
    return
else
    if iscell(varargin{1})
        param = varargin{1};
        cut = varargin{2};
        var = varargin{3};
        p=cell2struct(param(:,2)', param(:,1)',2);
        Z1 = p.Z1;
        Z2 = p.Z2;
        K1 = p.K1;
        K2 = p.K2;
        volf = p.volf;
        R = p.R;
        qr = cut(:,1); %%% for temporary....
    else
        q = varargin{1};
        p = varargin{2};
        if isfield(q, 'qpa')
            qr = q.qpa;
        else
            qr = q;
        end
        if isstruct(varargin{2})  % strfactor_2Dpara(q, str_param, R)
%            p=cell2struct(param(:,2)', param(:,1)',2);
            p = varargin{2};
            Z1 = p.Z1;
            Z2 = p.Z2;
            K1 = p.K1;
            K2 = p.K2;
            volf = p.volf;
            R = p.R;
        elseif iscell(varargin{2})
            param = varargin{2};
            p=cell2struct(param(:,2)', param(:,1)',2);
            Z1 = p.Z1;
            Z2 = p.Z2;
            K1 = p.K1;
            K2 = p.K2;
            volf = p.volf;
            R = p.R;
        else                        % strfactor_2Dpara(q, d, sig)
            Z1 = varargin{2};
            Z2 = varargin{3};
            K1 = varargin{4};
            K2 = varargin{5};
            volf = varargin{6};
            R = varargin{7};
        end
    end
end
%if (R <= 0) || (sig<=0)
%    Sq = ones(size(qr));
%    return;
%end
%sig
%d
Q=(0:0.004:18*10)*2*pi;
calSk = CalTYSk(Z1,Z2,K1,K2,volf,Q);
Q = Q/R;
Sq = spline(Q,calSk,qr);