function Sq = strfactor_DWBAHoly2(qr, qz1, qz2, sig1, sig2, zint1, zint2, roughparam)
% sig1 should be the interface roughness of the substrate...
% sig2 should be the number of the substrate, or N
% zint1 should be the number of layer of j
% zint1 should be the number of layer of k
N = sig2;
lj = zint1;
lk = zint2;

hcor = roughparam(1);
vcor = roughparam(2);
H = roughparam(3);

Sq = 1./(qz1.*qz2+eps).*integCorr_qyavg_best(qr, qz1, qz2, sig1, N, lj, lk, hcor, vcor, H);

function Sq = integCorr_qyavg(qx, qz1, qz2, sig1, N, lj, lk, hcor, vcor, H)
qx = real(qx);
Sq = qx;
for i=1:length(qz1)
    y = 0.01;
    rmax = hcor*exp(log(log(1/y))/2/H);
    rint = 1/10*pi/(abs(qx(i)) + eps);
    if rint > 0.2*rmax
        rint = 0.2*rmax;
    end
%    rmax=hcor*10;
    rr = 0:rint:rmax;
%    rr = 0:rmax/64:rmax;
    dr = rint;

    Cr = sig1^2*exp(-(rr/hcor).^(2*H));
%    Cr = Cr + N-max([lj, lk]);
    Cr = (exp((qz1(i).*qz2(i)).*Cr)-1).*cos(qx(i).*rr);
    Sq(i) = trapz(Cr)*dr;
end

function Sq = integCorr_qyavg_best(qx, qz1, qz2, sig1, N, lj, lk, hcor, vcor, H)
qx = real(qx);
qz1 = real(qz1);
qz2 = real(qz2);
Sq = qx;

y = 0.001;
rmax = hcor*exp(log(log(1/y))/2/H);
%    rmax=hcor*10;
    if isinf(rmax)
        rmax = 1E6;
    elseif rmax > 2E6;
        rmax = 1E6;
    end
%rmax = 1/abs(qx(end));
    rr = 0:rmax/2048:rmax;
    dr = rmax/2048;

for i=1:length(qz1)
    Cr = sig1^2*exp(-(rr/hcor).^(2*H));
%    Cr = Cr + N-max([lj, lk]);
    Cr = (exp((qz1(i).*qz2(i)).*Cr)-1).*rr.*besselj(0, qx(i).*rr);
    Sq(i) = trapz(Cr)*dr;
end

function Sq = integCorr_qyavg_old(qx, qz1, qz2, sig1, N, lj, lk, hcor, vcor, H)
qx = real(qx);
qz1 = real(qz1);
qz2 = real(qz2);
y = 0.001;
rmax = hcor*exp(log(log(1/y))/2/H);
%    rmax=hcor*10;
    if isinf(rmax)
        rmax = 1E6;
    elseif rmax > 2E6;
        rmax = 1E6;
    end
%rmax = 1/abs(qx(end));
    r = 0:rmax/2048:rmax;
    dr = rmax/2048;

    dimsofqr=1;dimsofqz=1;
if (prod(size(qx))>1) & (prod(size(qz1))==1)
    dimsofqr = size(qx);
    [qr, r] = ndgrid(qx, r);
elseif (prod(size(qx))==1) & (prod(size(qz1))>1)
    dimsofqr = size(qz1);
    qz1 = ndgrid(qz1, r);[qz2, r] = ndgrid(qz2, r);
elseif (prod(size(qx))==prod(size(qz1)))
    dimsofqr = size(qz1);
    [qr, a] = ndgrid(qx, r);
    [qz1, a] = ndgrid(qz1, r);
    [qz2, rr] = ndgrid(qz2, r);
end
Cr = sig1^2*exp(-(rr/hcor).^(2*H));
Cr = Cr + N-max([lj, lk]);
Cr = (exp((qz1.*qz2).*Cr)-1).*cos(qr.*rr);
Sq = trapz(Cr, 2)*dr;
Sq = reshape(Sq, dimsofqr);