function [org_A, index, ind2] = unique_m(A, res)
% similar with reducehk.m, but may be faster.
% function [A, index, ind2] = unique_m(A)
% example: [A,index, ind2] = unique_m([1,2,3;4,5,5;1,2,3])
% or use unique(A, 'rows'), which is the fastest.
% 
% 6/15/2013 modified.
% 7/9/2013, ind2 is added.
% Byeongdu Lee
if nargin < 2
    res = 1E8;
end
[~, index, ind2] = unique(round(A*res)/res, 'rows', 'stable');
org_A = A(index, :);