function SDD = SDDcal(pixel, qvalue, pixelsize, wavelength)
% calculation of SDD from standard sample.
% SDD = SDDcal(pixel, qvalue, pixelsize, wavelength)
%   pixel : where the peak of the standard sample occur
%   qvalue : corresponding qvalue for the peak of the standard sample in
%   Angstrom inverse unit.
%   pixelsize : pixelsize of detector in mm unit.
%   wavelength : wavelength in Angstrom unit.
angle = rad2deg(asin(wavelength * qvalue / (4 * pi)));
SDD = pixel * pixelsize / tan(2*deg2rad(angle));